# -*- coding: utf-8 -*-
"""
Created on Fri May 11 02:11:55 2018
[svm_03.py]
@author: kenken
"""
from sklearn.svm import SVC
from sklearn.model_selection import train_test_split
from sklearn.metrics import accuracy_score
import numpy as np
#from numpy._distributor_init import NUMPY_MKL #
import pandas as pd
#
# class:0
df_a=pd.DataFrame({'x1':np.random.randn(100),
                   'x2':np.random.randn(100),
                   'y':0})
# class:1
df_b=pd.DataFrame({'x1':np.random.randn(100)+5,
                   'x2':np.random.randn(100)+3,
                   'y':1})
#
##OK#df=df_a.append(df_b)#これだと、行が連番にならない
df=pd.concat([df_a,df_b],ignore_index=True)
#
print("------ランダム・データ、生成順に表示-------")
print(df)
#print("=============")
#　生成されたデータを散布図で表示す
# 
#　トレーニングデータとテストデータに分離する
X_train,X_test,y_train,y_test=train_test_split(df[['x1','x2']],df['y'],test_size=0.2)
#　モデルのインスタンスｗｐ生成
clf=SVC()
#　fit　学習
clf.fit(X_train,y_train)
#　predict　予測
y_pred=clf.predict(X_test)
print("******予測結果******")
print(y_pred)
print("")
#　正解率の計算
#　方法１
print("正解率；計算方法１ ",accuracy_score(y_test, y_pred))
#　方法２
print("正解率；計算方法２ ",np.mean(y_pred==y_test))
print("")
#　結果を散布図で表示する
#１．先ず、Xとyを結合する「列」方向
#（１）trainデータの結合
df_train=pd.concat([X_train,y_train],axis=1)
# axis=1 は「列」方向、axis=0は「行」方向
print("------教師用ランダム・データ、生成順もランダム化-------")
print(df_train)
print("~~~~~~~~~~~~~~~~~~~~~~~~")
#（２）testデータの結合
df_test=pd.concat([X_test,y_test],axis=1)
print("------試験用ランダム・データ、生成順もランダム化-------")
print(df_test)
print("~~~~~~~~~~~~~~~~~~~~~~~~")
#　動くけど、採用せず、だけど、これの方が良いみたい！！・・こっちでやってみる事
#２．y=0と1のデータを分離「行」方向
#（１）trainデータの分離
#　　A　y=0
df_train_0=df_train[df_train.y ==0]
print("------教師用データの内、［y=0］のもの-------")
print(df_train_0)
print("~~~~~~~~~~~~~~~~~~~~~~~~")
#　　B y=1
df_train_1=df_train[df_train.y ==1]
print("------教師用データの内、［y=1］のもの-------")
print(df_train_1)
print("~~~~~~~~~~~~~~~~~~~~~~~~")
#（２）testデータの結合の分離
#　　A　y=0
df_test_0=df_test[df_test.y ==0]
print("------試験用データの内、［y=0］のもの-------")
print(df_test_0)
print("~~~~~~~~~~~~~~~~~~~~~~~~")
#　　B y=1
df_test_1=df_test[df_test.y ==1]
print("------試験用データの内、［y=1］のもの-------")
print(df_test_1)
print("~~~~~~~~~~~~~~~~~~~~~~~~")
#３．「４つ」のFrameDataを散布図上に表示する
ax_1=df_train_0.plot(title='Random Data:[x1=0,x2=0] & [x1=5,x2=3]',x='x1', y='x2',kind='scatter',color="red",label="train_0")
plt_1=df_train_1.plot(ax=ax_1,x='x1', y='x2', kind='scatter',color="blue",label='train_1')
plt_2=df_test_0.plot(ax=ax_1,x='x1', y='x2', kind='scatter',marker='x',color="green",label='test_0')
plt_3=df_test_1.plot(ax=ax_1,x='x1', y='x2', kind='scatter',marker='x',color="magenta",label='test_1')
plt_3.get_figure()
#　一時的にコメント化、動作OK品
##df_new.plot(x='x1', y='x2',kind='scatter',c=df_new.set_color)#OKなんと動いた
